// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dataspeed_dbw_msgs:msg/MiscReport.idl
// generated code does not contain a copyright notice
#include "dataspeed_dbw_msgs/msg/detail/misc_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `turn_signal`
#include "dataspeed_dbw_msgs/msg/detail/turn_signal__functions.h"

bool
dataspeed_dbw_msgs__msg__MiscReport__init(dataspeed_dbw_msgs__msg__MiscReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dataspeed_dbw_msgs__msg__MiscReport__fini(msg);
    return false;
  }
  // turn_signal
  if (!dataspeed_dbw_msgs__msg__TurnSignal__init(&msg->turn_signal)) {
    dataspeed_dbw_msgs__msg__MiscReport__fini(msg);
    return false;
  }
  // btn_cc_on
  // btn_cc_off
  // btn_cc_on_off
  // btn_cc_res
  // btn_cc_cncl
  // btn_cc_res_cncl
  // btn_cc_res_inc
  // btn_cc_res_dec
  // btn_cc_set_inc
  // btn_cc_set_dec
  // btn_cc_gap_inc
  // btn_cc_gap_dec
  // btn_la_on_off
  // btn_ld_ok
  // btn_ld_up
  // btn_ld_down
  // btn_ld_left
  // btn_ld_right
  // btn_rd_ok
  // btn_rd_up
  // btn_rd_down
  // btn_rd_left
  // btn_rd_right
  // btn_vol_inc
  // btn_vol_dec
  // btn_mute
  // btn_media
  // btn_prev
  // btn_next
  // btn_speak
  // btn_call_start
  // btn_call_end
  // fault_bus
  // door_driver
  // door_passenger
  // door_rear_left
  // door_rear_right
  // door_hood
  // door_trunk
  // passenger_detect
  // passenger_airbag
  // buckle_driver
  // buckle_passenger
  return true;
}

void
dataspeed_dbw_msgs__msg__MiscReport__fini(dataspeed_dbw_msgs__msg__MiscReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // turn_signal
  dataspeed_dbw_msgs__msg__TurnSignal__fini(&msg->turn_signal);
  // btn_cc_on
  // btn_cc_off
  // btn_cc_on_off
  // btn_cc_res
  // btn_cc_cncl
  // btn_cc_res_cncl
  // btn_cc_res_inc
  // btn_cc_res_dec
  // btn_cc_set_inc
  // btn_cc_set_dec
  // btn_cc_gap_inc
  // btn_cc_gap_dec
  // btn_la_on_off
  // btn_ld_ok
  // btn_ld_up
  // btn_ld_down
  // btn_ld_left
  // btn_ld_right
  // btn_rd_ok
  // btn_rd_up
  // btn_rd_down
  // btn_rd_left
  // btn_rd_right
  // btn_vol_inc
  // btn_vol_dec
  // btn_mute
  // btn_media
  // btn_prev
  // btn_next
  // btn_speak
  // btn_call_start
  // btn_call_end
  // fault_bus
  // door_driver
  // door_passenger
  // door_rear_left
  // door_rear_right
  // door_hood
  // door_trunk
  // passenger_detect
  // passenger_airbag
  // buckle_driver
  // buckle_passenger
}

dataspeed_dbw_msgs__msg__MiscReport *
dataspeed_dbw_msgs__msg__MiscReport__create()
{
  dataspeed_dbw_msgs__msg__MiscReport * msg = (dataspeed_dbw_msgs__msg__MiscReport *)malloc(sizeof(dataspeed_dbw_msgs__msg__MiscReport));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dataspeed_dbw_msgs__msg__MiscReport));
  bool success = dataspeed_dbw_msgs__msg__MiscReport__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dataspeed_dbw_msgs__msg__MiscReport__destroy(dataspeed_dbw_msgs__msg__MiscReport * msg)
{
  if (msg) {
    dataspeed_dbw_msgs__msg__MiscReport__fini(msg);
  }
  free(msg);
}


bool
dataspeed_dbw_msgs__msg__MiscReport__Sequence__init(dataspeed_dbw_msgs__msg__MiscReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dataspeed_dbw_msgs__msg__MiscReport * data = NULL;
  if (size) {
    data = (dataspeed_dbw_msgs__msg__MiscReport *)calloc(size, sizeof(dataspeed_dbw_msgs__msg__MiscReport));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dataspeed_dbw_msgs__msg__MiscReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dataspeed_dbw_msgs__msg__MiscReport__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dataspeed_dbw_msgs__msg__MiscReport__Sequence__fini(dataspeed_dbw_msgs__msg__MiscReport__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dataspeed_dbw_msgs__msg__MiscReport__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dataspeed_dbw_msgs__msg__MiscReport__Sequence *
dataspeed_dbw_msgs__msg__MiscReport__Sequence__create(size_t size)
{
  dataspeed_dbw_msgs__msg__MiscReport__Sequence * array = (dataspeed_dbw_msgs__msg__MiscReport__Sequence *)malloc(sizeof(dataspeed_dbw_msgs__msg__MiscReport__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dataspeed_dbw_msgs__msg__MiscReport__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dataspeed_dbw_msgs__msg__MiscReport__Sequence__destroy(dataspeed_dbw_msgs__msg__MiscReport__Sequence * array)
{
  if (array) {
    dataspeed_dbw_msgs__msg__MiscReport__Sequence__fini(array);
  }
  free(array);
}
